/*
	FW2.xx+devhook homebrew sample
*/
#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <psptypes.h>
#include <pspiofilemgr.h>

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/unistd.h>

#if 1
PSP_MODULE_INFO("homebrew_2xx", 0x0000, 1, 1);
#else
// Kernel mode can't load yet
PSP_MODULE_INFO("homebrew_2xx", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);
#endif

#define printf pspDebugScreenPrintf

/* Exit callback */
int exit_callback(int arg1, int arg2, void *common)
{
	sceKernelExitGame();

	return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

int main(void)
{
	pspDebugScreenInit();
	SetupCallbacks();

	printf("\
         Welcome to FW2.XX+devhook homebrew world\n\
\n\
How to build the homebrew for FW2.xx+devhook\n\
1.use devkitPSP7 to the build.(I didn't check latest SDK)\n\
2.Edit SFO which was picked from Trial PBP with the binary editor.\n\
3.Set the BUILD_PRX=1 switch to relocatable compile.\n\
4.Choose a user module attribute.kernel mode module can't boot\n\
5.Pack the single PBP without 1.50 exploit.\n\
6.use FW2.00/2.50/2.60/2.71 + devhook 0.45.0000 or later.\n\
\n\
----------messages to PSP SDK developpers ----------\n\
\n\
1.more SFO information\n\
  FW2.xx needs more information.\n\
  current version of mksfo.exe doesn't make necessary information.\n\
\n\
2.ELF load error\n\
  in ms boot on FW2.50,2.60 and 2.71,\n\
  LoadCoreForKernel_Unkonow_54ab2675() return 0x80020148\n\
  and output to Kprintf\n\
\n\
  \"********************\"\n\
  \"PSP cannot load this image\"\n\
  \"unacceptable relocation type: 0x7\"\n\
\n\
  It is patched to the same operation as FW2.00 by plain2x.prx now.\n\
  An ELF with the higher compatibility is wanted for the future FW.\n\
");
	return 0;
}
